/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   event_control.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_EVENT_CONTROL_H
#define UHDM_EVENT_CONTROL_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/atomic_stmt.h>

#include "expr_sequence_inst_named_event_group.h"
#include "stmt.h"


namespace UHDM {


class event_control final : public atomic_stmt {
  UHDM_IMPLEMENT_RTTI(event_control, atomic_stmt)
public:
  // Implicit constructor used to initialize all members,
  // comment: event_control();
  virtual ~event_control() final = default;

  any* VpiCondition()  { return vpiCondition_; }
  const any* VpiCondition() const { return vpiCondition_; }
  template <typename T>
  T* VpiCondition() {
    return (vpiCondition_ == nullptr) ? nullptr : any_cast<T*>(vpiCondition_);
  }
  template <typename T>
  const T* VpiCondition() const {
    return (vpiCondition_ == nullptr) ? nullptr : any_cast<const T*>(vpiCondition_);
  }
  bool VpiCondition(any* data) {
    if (!expr_sequence_inst_named_event_groupGroupCompliant(data)) return false;
    vpiCondition_ = data;
    return true;
  }

  any* Stmt()  { return stmt_; }
  const any* Stmt() const { return stmt_; }
  template <typename T>
  T* Stmt() {
    return (stmt_ == nullptr) ? nullptr : any_cast<T*>(stmt_);
  }
  template <typename T>
  const T* Stmt() const {
    return (stmt_ == nullptr) ? nullptr : any_cast<const T*>(stmt_);
  }
  bool Stmt(any* data) {
    if (!stmtGroupCompliant(data)) return false;
    stmt_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiEventControl; }

  virtual event_control* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmevent_control; }

protected:
  void DeepCopy(event_control* clone, BaseClass* parent, CloneContext* context) const;

private:
  any* vpiCondition_ = nullptr;

  any* stmt_ = nullptr;
};


typedef FactoryT<event_control> event_controlFactory;


typedef FactoryT<std::vector<event_control *>> VectorOfevent_controlFactory;

}  // namespace UHDM

#endif
